com.holonplatform.datastore.jdbc.composer.expression

## Interface SQLProjection.MutableSQLProjection<R>

- Type Parameters:
    `R` - Projection type
  All Superinterfaces:
    com.holonplatform.core.Expression, SQLProjection<R>, com.holonplatform.core.TypedExpression<R>
  Enclosing interface:
    SQLProjection<R>

      public static interface SQLProjection.MutableSQLProjection<R>
      extends SQLProjection<R>

  A mutable `SQLProjection` to configure selection expressions and converter.

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface com.holonplatform.datastore.jdbc.composer.expression.SQLProjection

      `SQLProjection.MutableSQLProjection<R>`

    - ### Nested classes/interfaces inherited from interface com.holonplatform.core.Expression

      `com.holonplatform.core.Expression.ExpressionResolverFunction<E extends com.holonplatform.core.Expression,R extends com.holonplatform.core.Expression>, com.holonplatform.core.Expression.InvalidExpressionException`

  - ### Method Summary

    All Methods Instance Methods Abstract Methods Default Methods
    Modifier and Type | Method and Description
    --- | ---
    `default String` | `addSelection(String selection)` Add a selection expression, with selection alias auto-generation.
    `String` | `addSelection(String selection, boolean generateAlias)` Add a selection expression.
    `void` | `addSelection(String selection, String alias)` Add a selection expression with selection alias.
    `void` | `setConverter(SQLResultConverter<R> converter)` Set the result converter.

    - ### Methods inherited from interface com.holonplatform.datastore.jdbc.composer.expression.SQLProjection

      `create, create, create, getConverter, getSelection, getSelectionAlias`

    - ### Methods inherited from interface com.holonplatform.core.TypedExpression

      `getTemporalType, getType, isCollectionExpression, isConverterExpression`

    - ### Methods inherited from interface com.holonplatform.core.Expression

      `validate`

- - ### Method Detail

    - #### addSelection

          String addSelection(String selection,
                              boolean generateAlias)

      Add a selection expression.
      Parameters:
        `selection` - Selection to add (not null)
        `generateAlias` - Whether to generate an alias label for the selection expression
      Returns:
        If `generateAlias` was `true`, the generated selection alias. Given `selection` otherwise.

    - #### addSelection

          default String addSelection(String selection)

      Add a selection expression, with selection alias auto-generation.
      Parameters:
        `selection` - Selection to add (not null)
      Returns:
        The generated selection alias

    - #### addSelection

          void addSelection(String selection,
                            String alias)

      Add a selection expression with selection alias.
      Parameters:
        `selection` - Selection to add (not null)
        `alias` - Selection alias (not null)

    - #### setConverter

          void setConverter(SQLResultConverter<R> converter)

      Set the result converter.
      Parameters:
        `converter` - the `SQLResultConverter` to set

Copyright © 2019 The Holon Platform. All rights reserved.